#include <SoftwareSerial.h>              //Libreria inclusa in Arduino IDE

const int rxPin = 5;                     //RX sul Pin3 di Arduino
const int txPin = 4;                     //TX sul pin2 di Arduino
SoftwareSerial mySerial(rxPin, txPin);   //Impostiamo le porte seriali

int RELAY1=0;            //Pin RELAY1
int RELAY2=2;          //Pin RELAY2
int RELAY3=14;           //Pin RELAY3
int RELAY4=12;          //Pin RELAY4
String data;

int changeVal = 0;   //if cangeVal = "1", relay1on = HIGH; relay1off = LOW; else relay1on = LOW; relay1off = HIGH
//It is useful if you use commercial a relay, which inverted state.
int relay1on;
int relay1off;
int relay2on;
int relay2off;
int relay3on;
int relay3off;
int relay4on;
int relay4off;
int value1;
int value2;
int value3;
int value4;

void setup() 
{
   Serial.begin(9600);       
   mySerial.begin(9600);

   
  if (changeVal == 1) {
    relay1on = 1;
    relay1off = 0;
    relay2on = 1;
    relay2off = 0;
    relay3on = 1;
    relay3off = 0;
    relay4on = 1;
    relay4off = 0;
  }
  else {
    relay1on = 0;
    relay1off = 1;
    relay2on = 0;
    relay2off = 1;
    relay3on = 0;
    relay3off = 1;
    relay4on = 0;
    relay4off = 1;
  }
  value1 = relay1off;
  value2 = relay2off;
  value3 = relay3off;
  value4 = relay4off;
   
  pinMode(RELAY1, OUTPUT); // Configure the ESP8266 pin as a digital output pin
  digitalWrite(RELAY1, relay1off);
  pinMode(RELAY2, OUTPUT);
  digitalWrite(RELAY2, relay2off);
  pinMode(RELAY3, OUTPUT);
  digitalWrite(RELAY3, relay3off);
  pinMode(RELAY4, OUTPUT);
  digitalWrite(RELAY4, relay4off);
}

void loop() 
{
    int i=0;
    char ch=0;
    data="";
  while(mySerial.available()) {
    delay(10);
    char ch=mySerial.read();
    if(ch=='#')
    {break; }
    data += ch;
}

if (data.length() > 0) {
  Serial.println(data);

    /*COMANDO RELAY1*/
    if((data=="accendi il primo") || (data=="Accendi il primo"))
    { 
      digitalWrite(RELAY1, relay1on); // turn on relay
      Serial.print("RELAY1 is turned ON");
    }
    else if((data=="Spegni il primo") || (data=="spegni il primo"))
    {
      digitalWrite(RELAY1, relay1off);  // turn off relay
      Serial.print("RELAY1 is turned OFF");
    }

    /*COMANDO RELAY2*/
    else if((data=="accendi il secondo") || (data=="Accendi il secondo"))
    {
      digitalWrite(RELAY2, relay2on); // turn on relay
      Serial.print("LED2 is turned ON");
    }
    else if((data=="Spegni il secondo") || (data=="spegni il secondo"))
    {
      digitalWrite(RELAY2, relay2off);  // turn off relay
      Serial.print("LED2 is turned OFF");
    }


/*COMANDO RELAY3*/
    if((data=="accendi il terzo") || (data=="Accendi il terzo"))
    { 
      digitalWrite(RELAY3, relay3on); // turn on relay
      Serial.print("LED3 is turned ON");
    }
    else if((data=="Spegni il terzo") || (data=="spegni il terzo"))
    {
      digitalWrite(RELAY3, relay3off);  // turn off relay
      Serial.print("LED3 is turned OFF");
    }

    /*COMANDO RELAY4*/
    else if((data=="accendi il quarto") || (data=="Accendi il quarto"))
    {
      digitalWrite(RELAY4, relay4on); // turn on relay
      Serial.print("LED4 is turned ON");
    }
    else if((data=="Spegni il quarto") || (data=="spegni il quarto"))
    {
      digitalWrite(RELAY4, relay4off);  // turn off relay
      Serial.print("LED4 is turned OFF");
    }

    /*COMANDO tutti*/
    if((data=="Accendi tutti") || (data=="accendi tutti"))
    { 
      digitalWrite(RELAY1, relay1on);
      digitalWrite(RELAY2, relay2on);
      digitalWrite(RELAY3, relay3on); // turn on relay
      digitalWrite(RELAY4, relay4on);
      Serial.print("RELAY1/2/3/4 are turned ON");
    }
    else if((data=="Spegni tutti") || (data=="spegni tutti"))
    {
      digitalWrite(RELAY1, relay1off);
      digitalWrite(RELAY2, relay2off);
      digitalWrite(RELAY3, relay3off);  // turn off relay
      digitalWrite(RELAY4, relay4off);
      Serial.print("RELAY1/2/3/4 are turned OFF");
    } 
     /*COMANDO sequenza*/
    if((data=="Accendi tutti in sequenza") || (data=="accendi tutti in sequenza"))
    { 
      digitalWrite(RELAY1, relay1on);
      delay(250);
      digitalWrite(RELAY2, relay2on);
      delay(250);
      digitalWrite(RELAY3, relay3on); // turn on relay
      delay(250);
      digitalWrite(RELAY4, relay4on);
      Serial.print("RELAY1/2/3/4 are turned ON");
    }
    else if((data=="Spegni tutti in sequenza") || (data=="spegni tutti in sequenza"))
    {
       digitalWrite(RELAY4, relay4off);
      delay(250);
      digitalWrite(RELAY3, relay3off);
      delay(250);
      digitalWrite(RELAY2, relay3off);
      delay(250);
      digitalWrite(RELAY1, relay1off);  // turn off relay
      Serial.print("RELAY1/2/3/4 are turned OFF");
    } 
  }  
}
